/*
Спроектировать два класса, один из которых наследует другой по типу public (private).
Закрытой переменной в первом классе является указатель на символьную строку,
а во втором – целочисленная переменная. Функциями класса являются конструкторы без
параметров и с параметрами, деструкторы. Разработать виртуальную функцию, выводящую
на экран значения переменных. Создать по объекту в каждом классе и продемонстрировать
работу функций.
*/

#include <iostream>
#include <string.h>

using namespace std;

class One {
public:
	One();
	One(const char *input_str);
	~One();

	void setValue(const char *input_str);
	virtual void printVars();

private:
	char *str;
};

class Two: public One {
public:
	Two();
	Two(int input_value);
	~Two();

	void setValue(const int input_value);
	void printVars();

private:
	int value;
};

int main()
{
	One *pointer;

	pointer = new One;
	pointer->printVars();
	cout << endl;

	pointer = new Two;
	pointer->printVars();
	return 0;
}

One::One()
{
	setValue("test string");
}

One::One(const char *input_str)
{
	setValue(input_str);
}

One::~One()
{
	if (str) {
		delete str;
	}
}

void One::setValue(const char *input_str)
{
	str = new char [ strlen(input_str) + 1 ];
	strcpy(str, input_str);
}

void One::printVars()
{
	cout << "Str: " << str << endl;
}

Two::Two()
{
	setValue(123);
}

Two::Two(int input_value)
{
	setValue(input_value);
}

Two::~Two()
{
	setValue(0);
}

void Two::setValue(const int input_value)
{
	value = input_value;
}

void Two::printVars()
{
	One::printVars();
	cout << "Value: " << value << endl;
}