/*
Спроектировать класс для работы с символьными строками. Состав класса: 
- две закрытые переменные - указатель на символьную строку (char *s) и размер строки (int n);
- три конструктора: первый – без параметров, второй – с параметрами, третий – для создания копии объекта;
- функции доступа к закрытым членам класса: возвращение размера строки length(), извлечение символа с указанным индексом at(), установка символа строки setchar();
- функции работы со строками: определение длины строки strlen(), удаления фрагмента строки erase(), вставка фрагмента в строку insert(), добавления фрагмента в конец строки append(); 
- оператор-функции для перегрузки: операции присваивания (=) – для копирования строк, операции «+» - для «склеивания» объектов типа String;
- оператор-функции перегрузки операторов консольного вывода и ввода объектов класса.
Создать необходимое количество объектов и продемонстрировать работу спроектированных средств при использовании объектов.
*/

#include <iostream>

using namespace std;

class String {
public:
	String();
	String(const char *str);
	String(String &obj);

	int length();
	char at(int pos);
	void setchar(int pos, char symb);

	int strlen(const char *str);
	void erase(int from, int to);
	void insert(int pos, const char *str);
	void append(const char *str);

	String& operator+(String& str);
	String& operator=(const char *str);

	friend istream& operator>>(istream& in, String& str);
	friend ostream& operator<<(ostream& out, String& str);

private:
	char *s;
	int n;
};

int main()
{
	String str, str2;

	str = "bara";
	str2 = "beam";

	cout << "str: " << str << endl
		 << "\"" << str << "\".at(2): " << str.at(2) << endl
		 << "\"" << str << "\".length(): " << str.length() << endl;
	
	cout << "\"" << str << "\".setchar(2, 'z'): ";
	str.setchar(2, 'z');
	cout << str << endl;

	cout << "\"" << str << "\".erase(2, 2): ";
	str.erase(2, 2);
	cout << str << endl;

	cout << "\"" << str << "\".insert(2, \"d\"): ";
	str.insert(2, "d");
	cout << str << endl;

	cout << endl;


	cout << "str2: " << str2 << endl
		 << "\"" << str2 << "\".at(2): " << str2.at(2) << endl
		 << "\"" << str2 << "\".length(): " << str2.length() << endl;

	cout << "\"" << str2 << "\".setchar(3, 'p'): ";
	str2.setchar(3, 'p');
	cout << str2 << endl;

	cout << "\"" << str2 << "\".erase(1, 3): ";
	str2.erase(1, 3);
	cout << str2 << endl;

	cout << "\"" << str2 << "\".append(\"oom\"): ";
	str2.append("oom");
	cout << str2 << endl;

	cout << endl;


	cout << "Operator + : " << str + str2 << endl;

	cout << "Enter you string: ";
	cin >> str;
	str2 = str;
	cout << "You string (operator = ): " << str2 << endl;
	return 0;
}

String::String()
{
	s = NULL;
	n = 0;
}

String::String(const char *str)
{
	s = NULL;
	n = 0;
	append(str);
}

String::String(String &obj)
{
	s = NULL;
	n = 0;
	append(obj.s);
}

int String::length()
{
	return n;
}

char String::at(int pos)
{
	return s[pos];
}

void String::setchar(int pos, char symb)
{
	s[pos] = symb;
}

int String::strlen(const char *str)
{
	int len = 0;
	while (str[len] != '\0') {
		len++;
	}
	return len;
}

void String::erase(int from, int to)
{
	to++;

	for (int i = 0; s[i] != '\0'; i++) {
		s[i + from] = s[i + to];
	}

	n -= to - from;
	s[n] = '\0';
}

void String::insert(int pos, const char *str)
{
	int str_len = strlen(str);

	char *buf = new char [n + str_len + 1];

	for (int i = 0; i < pos; i++) {
		buf[i] = s[i];
	}

	for (int i = 0; i < str_len; i++) {
		buf[i + pos] = str[i];
	}

	for (int i = pos; i < n; i++) {
		buf[i + str_len] = s[i];
	}

	n += str_len;
	buf[n] = '\0';

	delete s;
	s = buf;
}

void String::append(const char *str)
{
	insert(n, str);
}

String& String::operator+(String& str)
{
	String *buf = new String;
	buf->append(s);
	buf->append(str.s);
	return *buf;
}

String& String::operator=(const char *str)
{
	String *buf = new String(str);
	s = buf->s;
	n = buf->n;
	return *buf;
}

istream& operator>>(istream& in, String& str)
{
	in >> str.s;
	str.n = str.strlen(str.s);
	return in;
}

ostream& operator<<(ostream& out, String& str)
{
	out << str.s;
	return out;
}